theta_vec=[30 10 15 20 25 30 35 40 45 50 55 60 65 70 75];

% for i=1:length(theta_vec)
i=1;
theta=theta_vec(i)*pi/180; % angle of coated wire
m_backform=20; % in kg
g=9.807; % m/s/s
F_backform=m_backform*g*sin(23*pi/180)/2; % 23 degree angle of seat, one half of system modeled
Load=[0 0 0 0 0 0 0 0 0 F_backform/sin(theta)*cos(theta) F_backform 0]'; % in Newtons
% Load=[0 0 0 0 0 0 0 0 0 0 10 0]'; % in Newtons, Force in pos. y-dir on node 5, test case
% y component in coated wire equal to back form load for equilibrium
% no moment, free rotation of coated wire w.r.t. black plastic

E=1.75*10^9; % GPa, PP
d1=3/1000; % m
d2=34/1000; % m
A=d1*d2; % m^2
I=d2*d1^3/12; % m^4

L_1=10/1000;
theta_1=2*pi-atan(8/6);
L_2=24.41311123/1000;
theta_2=atan(14/20);
L_3=50/1000;
theta_3=2*pi-atan(3/4);
L_4=36.05551275/1000;
theta_4=atan(30/20);

L_c=sqrt((L_1*cos(theta_1)+L_2*cos(theta_2)+L_3*cos(theta_3)+L_4*cos(theta_4))^2+(L_1*sin(theta_1)+L_2*sin(theta_2)+L_3*sin(theta_3)+L_4*sin(theta_4))^2);
A_c=pi*1.6^2/4/1000/1000; % m^2, cross sectional area of cable
% A_c=0; % eliminate 'cable'
E_c=200*10^9; % GPa, steel (cable)
theta_c=atan((L_1*sin(theta_1)+L_2*sin(theta_2)+L_3*sin(theta_3)+L_4*sin(theta_4))/(L_1*cos(theta_1)+L_2*cos(theta_2)+L_3*cos(theta_3)+L_4*cos(theta_4)));

% test case, 4 horizontal beams
% L_1=10/1000; % m
% L_2=10/1000; % m
% L_3=10/1000; % m
% L_4=10/1000; % m
% L_c=40/1000; % m
% theta_1=0;
% theta_2=0;
% theta_3=0;
% theta_4=0;
% theta_c=0;

K_1=[E*A/L_1 0 0 -E*A/L_1 0 0;
0 12*E*I/L_1^3 6*E*I/L_1^2 0 -12*E*I/L_1^3 6*E*I/L_1^2;
0 6*E*I/L_1^2 4*E*I/L_1 0 -6*E*I/L_1^2 2*E*I/L_1;
-E*A/L_1 0 0 E*A/L_1 0 0;
0 -12*E*I/L_1^3 -6*E*I/L_1^2 0 12*E*I/L_1^3 -6*E*I/L_1^2;
0 6*E*I/L_1^2 2*E*I/L_1 0 -6*E*I/L_1^2 4*E*I/L_1];

K_2=[E*A/L_2 0 0 -E*A/L_2 0 0;
0 12*E*I/L_2^3 6*E*I/L_2^2 0 -12*E*I/L_2^3 6*E*I/L_2^2;
0 6*E*I/L_2^2 4*E*I/L_2 0 -6*E*I/L_2^2 2*E*I/L_2;
-E*A/L_2 0 0 E*A/L_2 0 0;
0 -12*E*I/L_2^3 -6*E*I/L_2^2 0 12*E*I/L_2^3 -6*E*I/L_2^2;
0 6*E*I/L_2^2 2*E*I/L_2 0 -6*E*I/L_2^2 4*E*I/L_2];

K_3=[E*A/L_3 0 0 -E*A/L_3 0 0;
0 12*E*I/L_3^3 6*E*I/L_3^2 0 -12*E*I/L_3^3 6*E*I/L_3^2;
0 6*E*I/L_3^2 4*E*I/L_3 0 -6*E*I/L_3^2 2*E*I/L_3;
-E*A/L_3 0 0 E*A/L_3 0 0;
0 -12*E*I/L_3^3 -6*E*I/L_3^2 0 12*E*I/L_3^3 -6*E*I/L_3^2;
0 6*E*I/L_3^2 2*E*I/L_3 0 -6*E*I/L_3^2 4*E*I/L_3];

K_4=[E*A/L_4 0 0 -E*A/L_4 0 0;
0 12*E*I/L_4^3 6*E*I/L_4^2 0 -12*E*I/L_4^3 6*E*I/L_4^2;
0 6*E*I/L_4^2 4*E*I/L_4 0 -6*E*I/L_4^2 2*E*I/L_4;
-E*A/L_4 0 0 E*A/L_4 0 0;
0 -12*E*I/L_4^3 -6*E*I/L_4^2 0 12*E*I/L_4^3 -6*E*I/L_4^2;
0 6*E*I/L_4^2 2*E*I/L_4 0 -6*E*I/L_4^2 4*E*I/L_4];

K_c=[E_c*A_c/L_c 0 0 -E_c*A_c/L_c 0 0;
0 0 0 0 0 0;
0 0 0 0 0 0;
-E_c*A_c/L_c 0 0 E_c*A_c/L_c 0 0;
0 0 0 0 0 0;
0 0 0 0 0 0];

R_1=[cos(theta_1) sin(theta_1) 0 0 0 0;
-sin(theta_1) cos(theta_1) 0 0 0 0;
0 0 1 0 0 0;
0 0 0 cos(theta_1) sin(theta_1) 0;
0 0 0 -sin(theta_1) cos(theta_1) 0;
0 0 0 0 0 1];

R_2=[cos(theta_2) sin(theta_2) 0 0 0 0;
-sin(theta_2) cos(theta_2) 0 0 0 0;
0 0 1 0 0 0;
0 0 0 cos(theta_2) sin(theta_2) 0;
0 0 0 -sin(theta_2) cos(theta_2) 0;
0 0 0 0 0 1];

R_3=[cos(theta_3) sin(theta_3) 0 0 0 0;
-sin(theta_3) cos(theta_3) 0 0 0 0;
0 0 1 0 0 0;
0 0 0 cos(theta_3) sin(theta_3) 0;
0 0 0 -sin(theta_3) cos(theta_3) 0;
0 0 0 0 0 1];

R_4=[cos(theta_4) sin(theta_4) 0 0 0 0;
-sin(theta_4) cos(theta_4) 0 0 0 0;
0 0 1 0 0 0;
0 0 0 cos(theta_4) sin(theta_4) 0;
0 0 0 -sin(theta_4) cos(theta_4) 0;
0 0 0 0 0 1];

R_c=[cos(theta_c) sin(theta_c) 0 0 0 0;
-sin(theta_c) cos(theta_c) 0 0 0 0;
0 0 1 0 0 0;
0 0 0 cos(theta_c) sin(theta_c) 0;
0 0 0 -sin(theta_c) cos(theta_c) 0;
0 0 0 0 0 1];

K_1_t=R_1'*K_1*R_1;
K_2_t=R_2'*K_2*R_2;
K_3_t=R_3'*K_3*R_3;
K_4_t=R_4'*K_4*R_4;
K_c_t=R_c'*K_c*R_c;

K=zeros(15,15);
K(1:6,1:6)=K_1_t;
K(1:3,1:3)=K(1:3,1:3)+K_c_t(1:3,1:3);
K(1:3,13:15)=K(1:3,13:15)+K_c_t(1:3,4:6);
K(4:9,4:9)=K(4:9,4:9)+K_2_t;
K(7:12,7:12)=K(7:12,7:12)+K_3_t;
K(10:15,10:15)=K(10:15,10:15)+K_4_t;
K(13:15,1:3)=K(13:15,1:3)+K_c_t(4:6,1:3);
K(13:15,13:15)=K(13:15,13:15)+K_c_t(4:6,4:6);

K_bc=K(4:15,4:15);
disp_xy=inv(K_bc)*Load

x1=[0 L_1*cos(theta_1) L_1*cos(theta_1)+L_2*cos(theta_2) L_1*cos(theta_1)+L_2*cos(theta_2)+L_3*cos(theta_3) L_1*cos(theta_1)+L_2*cos(theta_2)+L_3*cos(theta_3)+L_4*cos(theta_4)]';
y1=[0 L_1*sin(theta_1) L_1*sin(theta_1)+L_2*sin(theta_2) L_1*sin(theta_1)+L_2*sin(theta_2)+L_3*sin(theta_3) L_1*sin(theta_1)+L_2*sin(theta_2)+L_3*sin(theta_3)+L_4*sin(theta_4)]';
x2=x1+[0 disp_xy(1) disp_xy(4) disp_xy(7) disp_xy(10)]';
y2=y1+[0 disp_xy(2) disp_xy(5) disp_xy(8) disp_xy(11)]';

x1_c=[0 L_1*cos(theta_1)+L_2*cos(theta_2)+L_3*cos(theta_3)+L_4*cos(theta_4)]';
y1_c=[0 L_1*sin(theta_1)+L_2*sin(theta_2)+L_3*sin(theta_3)+L_4*sin(theta_4)]';
x2_c=x1_c+[0 disp_xy(10)]';
y2_c=y1_c+[0 disp_xy(11)]';

L_c_i=sqrt(x1_c(2)^2+y1_c(2)^2);
L_c_f=sqrt(x2_c(2)^2+y2_c(2)^2);
delta_L_c=L_c_f-L_c_i;
F_c(i)=E_c*A_c/L_c*delta_L_c;

% end

figure(1)
title('Initial and final positions of nodes')
plot(x1,y1,'--r*',x2,y2,'--go',x1_c,y1_c,'--r*',x2_c,y2_c,'--go')
xlabel('x-position (m)')
ylabel('y-position (m)')
legend('Initial position','Final position')
axis([-0.05 0.125 -0.05 0.125],"square")

% disp_xy_b=K(4:15,4:15)\Load;
% x1_b=[0 L_1*cos(theta_1)]';
% y1_b=[0 L_1*sin(theta_1)]';
% x2_b=x1_b+[0 disp_xy_b(1)]';
% y2_b=y1_b+[0 disp_xy_b(2)]';

% figure(2)
% title('Initial and final positions of nodes')
% plot(x1_b,y1_b,'--r*',x2_b,y2_b,'--go')
% xlabel('x-position (m)')
% ylabel('y-position (m)')
% legend('Initial position','Final position')

% figure(1)
% title('Cable load vs. coated wire angle')
% plot(theta_vec,F_c)
% xlabel('Angle of coated wire (degrees)')
% ylabel('Braided steel cable load (N)')





